package jsp.graphs;

import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;

public final class updatingGraphJS_jsp extends org.apache.jasper.runtime.HttpJspBase
    implements org.apache.jasper.runtime.JspSourceDependent {

  private static final JspFactory _jspxFactory = JspFactory.getDefaultFactory();

  private static java.util.List<String> _jspx_dependants;

  private javax.el.ExpressionFactory _el_expressionfactory;
  private org.apache.tomcat.InstanceManager _jsp_instancemanager;

  public java.util.List<String> getDependants() {
    return _jspx_dependants;
  }

  public void _jspInit() {
    _el_expressionfactory = _jspxFactory.getJspApplicationContext(getServletConfig().getServletContext()).getExpressionFactory();
    _jsp_instancemanager = org.apache.jasper.runtime.InstanceManagerFactory.getInstanceManager(getServletConfig());
  }

  public void _jspDestroy() {
  }

  public void _jspService(HttpServletRequest request, HttpServletResponse response)
        throws java.io.IOException, ServletException {

    PageContext pageContext = null;
    HttpSession session = null;
    ServletContext application = null;
    ServletConfig config = null;
    JspWriter out = null;
    Object page = this;
    JspWriter _jspx_out = null;
    PageContext _jspx_page_context = null;


    try {
      response.setContentType("text/javascript");
      pageContext = _jspxFactory.getPageContext(this, request, response,
      			null, true, 8192, true);
      _jspx_page_context = pageContext;
      application = pageContext.getServletContext();
      config = pageContext.getServletConfig();
      session = pageContext.getSession();
      out = pageContext.getOut();
      _jspx_out = out;

      out.write("\r\n// =============== Infrastructure ==============\r\n// SVG namespace\r\nvar svgNS = \"http://www.w3.org/2000/svg\";\r\n// the SVG document\r\nvar graphDocument = null;\r\n// The main <g> element that groups all graph elements\r\nvar graphGroup = null;\r\n// The selected point\r\nvar selectedPoint = null;\r\n// All points\r\nvar allPoints = new Array(60);\r\n// The path through all of the points\r\nvar dataPath = null;\r\n// The space to the left of the graph\r\nvar xOffset = 100;\r\n// The space above the graph\r\nvar yOffset = 50;\r\n// The height of the graph\r\nvar graphHeight;\r\n// The length of the graph\r\nvar graphLength;\r\n\r\n// =============== Runtime Data ==============\r\n// Data\r\nvar data = new Array(60);\r\n// Y-Max\r\nvar yMax = 1;\r\n// Y Caption\r\nvar yCaption = null;\r\n// Bottom Caption\r\nvar lowerCaption = null;\r\n\r\n/** Saved bootstrap reference **/\r\nfunction initialize(evt, length, height, updater, caption) {\r\n  // Get the document\r\n  graphDocument = evt.target.ownerDocument;\r\n  renderChart(length, height, updater, caption);\r\n}\r\n\r\n/** Sets up the initial objects and draws the chart **/\r\n");
      out.write("function renderChart(length, height, updater, captionText) {\r\n  graphLength = length;\r\n  graphHeight = height;\r\n  for(var i=0; i<data.length; i++) {\r\n    data[i] = 0;\r\n  }\r\n\r\n  // Create the group\r\n  graphGroup = graphDocument.createElementNS(svgNS, \"g\");\r\n\r\n  // Create the caption\r\n  var caption = graphDocument.createElementNS(svgNS, \"text\");\r\n  caption.setAttribute(\"x\", (xOffset+length)/2);\r\n  caption.setAttribute(\"y\", 20);\r\n  caption.setAttribute(\"text-anchor\", \"middle\");\r\n  caption.appendChild(graphDocument.createTextNode(captionText));\r\n  graphGroup.appendChild(caption);\r\n\r\n  // Create the axes\r\n  var axisGroup = graphDocument.createElementNS(svgNS, \"g\");\r\n  // create the X axis line as a <path> element\r\n  var axisPath = graphDocument.createElementNS(svgNS, \"path\");\r\n  // X axis line settings\r\n  axisPath.setAttribute(\"stroke\", \"black\");\r\n  axisPath.setAttribute(\"stroke-width\", \"2\");\r\n  axisPath.setAttribute(\"fill\", \"none\");\r\n  axisPath.setAttribute(\"d\", \"M \"+xOffset+\" \"+yOffset+\" L \"+xOffset+\" \"+(yOffset+graphHeight)+\" L \"+(xOffset+graphLength)+\" \"+(yOffset+graphHeight));\r\n");
      out.write("  axisGroup.appendChild(axisPath);\r\n  var topY = graphDocument.createElementNS(svgNS, \"text\");\r\n  topY.setAttribute(\"x\", 1);\r\n  topY.setAttribute(\"y\", yOffset+10);\r\n  yCaption = graphDocument.createTextNode(\"Max MB\");\r\n  topY.appendChild(yCaption);\r\n  axisGroup.appendChild(topY);\r\n  // Done with axes\r\n  graphGroup.appendChild(axisGroup);\r\n\r\n  // Create the points\r\n  for(var i=0; i<allPoints.length; i++) {\r\n    allPoints[i] = graphDocument.createElementNS(svgNS, \"circle\");\r\n    allPoints[i].setAttribute(\"cx\", xOffset+(i*graphLength/(data.length-1)));\r\n    allPoints[i].setAttribute(\"cy\", yOffset+graphHeight);\r\n    allPoints[i].setAttribute(\"r\", 2);\r\n    allPoints[i].setAttribute(\"fill\", \"blue\");\r\n  }\r\n\r\n  // Create the data path\r\n  dataPath = graphDocument.createElementNS(svgNS, \"path\");\r\n  dataPath.setAttribute(\"stroke\", \"black\");\r\n  dataPath.setAttribute(\"stroke-width\", \"1\");\r\n  dataPath.setAttribute(\"fill\", \"none\");\r\n\r\n  // add the data path to the chart group\r\n  graphGroup.appendChild(dataPath);\r\n  // add the points on top of the data path\r\n");
      out.write("  for(var i = 0; i < allPoints.length; i++) {\r\n    graphGroup.appendChild(allPoints[i]);\r\n  }\r\n\r\n  // Render initial data\r\n  syncPoints();\r\n  setPathDef();\r\n\r\n  graphDocument.documentElement.appendChild(graphGroup);\r\n  setTimeout(updater, 100);\r\n}\r\n\r\n/** Updates the points to the most current data **/\r\nfunction syncPoints() {\r\n//  for(var i = 0; i < data.length; i++) {\r\n//    if(data[i] > yMax) {\r\n//      yMax = data[i] * 1.3;\r\n//    }\r\n//  }\r\n  var bottom = yOffset+graphHeight;\r\n  var ratio = graphHeight/yMax;\r\n  for(var i = 0; i < data.length; i++) {\r\n    allPoints[i].setAttribute(\"cy\", bottom-(data[i]*ratio));\r\n  }\r\n}\r\n\r\n/** Updates the path to go through all the points **/\r\nfunction setPathDef() {\r\n  var pathDef = \"\";\r\n  for(var i = 0; i < allPoints.length; i++) {\r\n    if(pathDef == \"\") {\r\n      pathDef += \"M \"+allPoints[i].getAttribute(\"cx\")+\" \"+allPoints[i].getAttribute(\"cy\");\r\n    } else {\r\n      pathDef += \"L \"+allPoints[i].getAttribute(\"cx\")+\" \"+allPoints[i].getAttribute(\"cy\");\r\n    }\r\n  }\r\n  dataPath.setAttribute(\"d\", pathDef);\r\n");
      out.write("}\r\n\r\n/** Adds a data point **/\r\nfunction addPoint(value) {\r\n  for(var i=0; i<data.length-1; i++) {\r\n    data[i] = data[i+1];\r\n  }\r\n  data[data.length-1] = value\r\n  syncPoints();\r\n  setPathDef();\r\n}\r\n\r\n/** Ensures the Y axis is at least this large **/\r\nfunction checkMaxValue(value, text) {\r\n  if(value > yMax) {\r\n    yMax = value;\r\n    yCaption.data = text;\r\n  }\r\n}\r\n\r\n/** Sets the maximum Y value to the specified value **/\r\nfunction setMaxValue(value, text) {\r\n  yMax = value;\r\n  yCaption.data = text;\r\n}\r\n\r\n/** Sets the lower caption **/\r\nfunction setLowerCaption(text) {\r\n  if(lowerCaption == null) {\r\n    var caption = graphDocument.createElementNS(svgNS, \"text\");\r\n    caption.setAttribute(\"x\", (xOffset+graphLength)/2);\r\n    caption.setAttribute(\"y\", yOffset+graphHeight+30);\r\n    caption.setAttribute(\"text-anchor\", \"middle\");\r\n    lowerCaption = graphDocument.createTextNode(\"   \"+text+\"   \");\r\n    caption.appendChild(lowerCaption);\r\n    graphGroup.appendChild(caption);\r\n  }\r\n  lowerCaption.data = \"  \"+text+\"  \";\r\n");
      out.write("}\r\n");
    } catch (Throwable t) {
      if (!(t instanceof SkipPageException)){
        out = _jspx_out;
        if (out != null && out.getBufferSize() != 0)
          try { out.clearBuffer(); } catch (java.io.IOException e) {}
        if (_jspx_page_context != null) _jspx_page_context.handlePageException(t);
      }
    } finally {
      _jspxFactory.releasePageContext(_jspx_page_context);
    }
  }
}
